#include "tclobj.h"

int giCTclObjMethods = 6;

OotMethodEntry gpCTclObjMethods[] = 
{
  {"setVoid", OOT_PARAM_TYPE_VOID, CTclObj::CBSetVoid},
  {"setBool", OOT_PARAM_TYPE_BOOL, CTclObj::CBSetBool},
  {"setInt", OOT_PARAM_TYPE_INT, CTclObj::CBSetInt},
  {"setFloat", OOT_PARAM_TYPE_FLOAT, CTclObj::CBSetFloat},
  {"setDouble", OOT_PARAM_TYPE_DOUBLE, CTclObj::CBSetDouble},
  {"setOther", OOT_PARAM_TYPE_OTHER, CTclObj::CBSetOther}
};

CTclObj::CTclObj()
{
  m_b = FALSE;
  m_i = 0;
  m_f = 0.0;
  m_d = 0.0;
}

CTclObj::~CTclObj()
{
}

int CTclObj::CBHandleCreate(OotObject *pObject, int /*argc*/, char ** /*argv*/)
{
  CTclObj *pCTclObj;

  ASSERT( pObject != NULL );

  pCTclObj = new CTclObj;
  ASSERT( pCTclObj != NULL );

  pObject->pvClientData = pCTclObj;

  return TCL_OK;
}

static CHAR gpcBuffer[200];

int CTclObj::CBSetVoid(Tcl_Interp *pInterp, OotObject *pObject)
{
  CTclObj *pCTclObj;

  ASSERT( pInterp != NULL && pObject != NULL );

  pCTclObj = (CTclObj*)(pObject->pvClientData);
  ASSERT( pCTclObj != NULL );

  printf("void do nothing\n");
  gpcBuffer[0] = '\0';
  Tcl_AppendResult(pInterp, gpcBuffer, NULL);

  return TCL_OK;
}

int CTclObj::CBSetBool(Tcl_Interp *pInterp, OotObject *pObject, BOOL b)
{
  CTclObj *pCTclObj;

  ASSERT( pInterp != NULL && pObject != NULL );

  pCTclObj = (CTclObj*)(pObject->pvClientData);
  ASSERT( pCTclObj != NULL );

  pCTclObj->m_b = b;
  printf("b = %ld\n", (UINT_32)(pCTclObj->m_b));
  sprintf(gpcBuffer, "%ld", (UINT_32)(pCTclObj->m_b));
  Tcl_AppendResult(pInterp, gpcBuffer, NULL);

  return TCL_OK;
}

int CTclObj::CBSetInt(Tcl_Interp *pInterp, OotObject *pObject, INT_32 i)
{
  CTclObj *pCTclObj;

  ASSERT( pInterp != NULL && pObject != NULL );

  pCTclObj = (CTclObj*)(pObject->pvClientData);
  ASSERT( pCTclObj != NULL );

  pCTclObj->m_i = i;
  printf("i = %ld\n", pCTclObj->m_i);
  sprintf(gpcBuffer, "%ld", pCTclObj->m_i);
  Tcl_AppendResult(pInterp, gpcBuffer, NULL);

  return TCL_OK;
}

int CTclObj::CBSetFloat(Tcl_Interp *pInterp, OotObject *pObject, FLOAT f)
{
  CTclObj *pCTclObj;

  ASSERT( pInterp != NULL && pObject != NULL );

  pCTclObj = (CTclObj*)(pObject->pvClientData);
  ASSERT( pCTclObj != NULL );

  pCTclObj->m_f = f;
  printf("f = %f\n", pCTclObj->m_f);
  sprintf(gpcBuffer, "%f", pCTclObj->m_f);
  Tcl_AppendResult(pInterp, gpcBuffer, NULL);

  return TCL_OK;
}

int CTclObj::CBSetDouble(Tcl_Interp *pInterp, OotObject *pObject, DOUBLE d)
{
  CTclObj *pCTclObj;

  ASSERT( pInterp != NULL && pObject != NULL );

  pCTclObj = (CTclObj*)(pObject->pvClientData);
  ASSERT( pCTclObj != NULL );

  pCTclObj->m_d = d;
  printf("d = %f\n", pCTclObj->m_d);
  sprintf(gpcBuffer, "%f", pCTclObj->m_d);
  Tcl_AppendResult(pInterp, gpcBuffer, NULL);

  return TCL_OK;
}

int CTclObj::CBSetOther(Tcl_Interp *pInterp, OotObject *pObject, int argc, char **argv)
{
  CTclObj *pCTclObj;
  UINT_32 i;

  ASSERT( pInterp != NULL && pObject != NULL );

  pCTclObj = (CTclObj*)(pObject->pvClientData);
  ASSERT( pCTclObj != NULL );

  printf("other argc = %d\n", argc);
  for ( i = 0; i < (UINT_32)argc; i++ )
    {
      Tcl_AppendResult(pInterp, argv[i], " ", NULL);
    }

  return TCL_OK;
}











